
def zip_longest(*args, fillvalue=0):
    from itertools import zip_longest
    from collections import deque

    def _ensure_same_length(iterables):
        max_length = max(len(it) for it in iterables)
        return (deque(it, maxlen=max_length) for it in iterables)

    return zip_longest(*_ensure_same_length(args), fillvalue=fillvalue)



